#include "stm32f0xx_conf.h"
#include "f0xx-pcd8544.h"
#include "font6x8.h"     // 


//   LCD_CS
#define LCD_CS1   GPIO_SetBits  (LCD_PORT, SCE)
#define LCD_CS0   GPIO_ResetBits(LCD_PORT, SCE)
//   LCD_RST
#define LCD_RST1  GPIO_SetBits  (LCD_PORT, RST)
#define LCD_RST0  GPIO_ResetBits(LCD_PORT, RST)
//   LCD_DC
#define LCD_DC1   GPIO_SetBits  (LCD_PORT, DC)
#define LCD_DC0   GPIO_ResetBits(LCD_PORT, DC)
//   LCD_SCK
#define LCD_SCK1   GPIO_SetBits  (LCD_PORT, SCLK)
#define LCD_SCK0   GPIO_ResetBits(LCD_PORT, SCLK)
//   LCD_MOSI
#define LCD_MOSI1   GPIO_SetBits  (LCD_PORT, MOSI)
#define LCD_MOSI0   GPIO_ResetBits(LCD_PORT, MOSI)

unsigned char lcd8544_buff[84*6]; //  

void lcd8544_Pause(void)
{
    volatile uint8_t i=0;
    for (i=0;i<200;i++);
}

//  \  
void lcd8544_senddata(unsigned char data)
{
    SPI_Send((uint8_t)data);
    /*
    unsigned char i;
    for(i=0;i<8;i++) {
       if (data & 0x80)
       {
          LCD_MOSI1;
       }
       else
       {
          LCD_MOSI0;
       }
       data = data<<1;
       LCD_SCK0;
       int i = 0;
       while(i<100)
       {
          i++;
       }
       i--;
       LCD_SCK1;
       i = 0;
             while(i<100)
             {
                i++;
             }
       i--;
    }
    */
}

//    
void lcd8544_refresh(void)
{
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE);
//    DMA_Cmd(DMA1_Channel3, DISABLE);

    LCD_CS0;            // S=0 -     
    lcd8544_Pause();
    LCD_DC0;            //  
    lcd8544_Pause();

    lcd8544_senddata(0x40); //     Y=0; X=0
    lcd8544_senddata(0x80);

    lcd8544_Pause();
    LCD_DC1;            //  
    lcd8544_Pause();

    unsigned char y, x;

    for (y=0; y<6; y++) for (x=0; x<84; x++) lcd8544_senddata(lcd8544_buff[y*84+x]);

}

////    
//void lcd8544_dma_refresh(void)
//{
//
//
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE);
//    DMA_Cmd(DMA1_Channel3, DISABLE);
//
//    LCD_CS0;            // S=0 -     
//
//    LCD_DC0;            //  
//    lcd8544_senddata(0x40); //     Y=0; X=0
//    lcd8544_senddata(0x80);
//
//    LCD_DC1;            //  
//    while (!(SPI1->SR & SPI_SR_TXE)); // Wait for bus free
//    while (SPI1->SR & SPI_SR_BSY);
//    SPI_Cmd(SPI1, DISABLE);
//    DMA_SetCurrDataCounter(DMA1_Channel3,84*6);
//    SPI_Cmd(SPI1, ENABLE);
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, ENABLE);
//    DMA_Cmd(DMA1_Channel3, ENABLE);
//
//
////   startSPI3();
//    /*
//       unsigned char y, x;
//
//       for (y=0;y<6;y++) for (x=0;x<84;x++) lcd8544_senddata(lcd8544_buff[y*84+x]);
//    */
//}
// 
void lcd8544_init(void)
{

    //RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
    //GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE); // SWD Remap ( PA15, PB3, PB4)
//   GPIO_PinRemapConfig(GPIO_Remap_SWJ_Disable, ENABLE);


    RCC_APB2PeriphClockCmd(LCD_PH, ENABLE);

    GPIO_InitTypeDef GPIO_InitStructure;

    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;    //   .
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;   //    .
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; //   .
    GPIO_InitStructure.GPIO_Pin   = DC | RST | SCE ; //SCLK | MOSI |
    GPIO_Init(LCD_PORT, &GPIO_InitStructure);

    init_spi();
//    init_dma_to_spi();

//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE);
//    DMA_Cmd(DMA1_Channel3, DISABLE);

    LCD_SCK0;
    lcd8544_Pause();
//     GPIO_SetBits(GPIOB, GPIO_Pin_3);
    //  
    LCD_CS0;            // CS=0  -     
    lcd8544_Pause();
    LCD_RST0;           // RST=0 -  
    lcd8544_Pause();
    LCD_RST1;           // RST=1
    lcd8544_Pause();
    //   
    LCD_DC0;            //  
    lcd8544_Pause();

    lcd8544_senddata(0x21);      //    
    lcd8544_senddata(0xC1);

    lcd8544_senddata(0x06);      //  ,  4  7

    lcd8544_senddata(0x13);      // Bias 0b0001 0xxx -   

    lcd8544_senddata(0x20);    //    
    lcd8544_senddata(0b1100);       // 0b1100 - normal mode
    // 0b1101 - invert mode
    // 0b1001 -   
    // 0b1000 -  

    lcd8544_Pause();
    LCD_DC1;            //  
    lcd8544_Pause();

    lcd8544_refresh();
}

//  
void lcd8544_putpix(unsigned char x, unsigned char y, unsigned char mode)
{
    if ((x>84) || (y>47)) return;

    unsigned int adr=(y>>3)*84+x;
    unsigned char data=(1<<(y&0x07));

    if (mode) lcd8544_buff[adr]|=data;
    else lcd8544_buff[adr]&=~data;
}



//   
void lcd8544_line(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char mode)
{
    signed char   dx, dy, sx, sy;
    unsigned char  x,  y, mdx, mdy, l;


    dx=x2-x1;
    dy=y2-y1;

    if (dx>=0)
    {
        mdx=dx;
        sx=1;
    }
    else
    {
        mdx=x1-x2;
        sx=-1;
    }
    if (dy>=0)
    {
        mdy=dy;
        sy=1;
    }
    else
    {
        mdy=y1-y2;
        sy=-1;
    }

    x=x1;
    y=y1;

    if (mdx>=mdy)
    {
        l=mdx;
        while (l>0)
        {
            if (dy>0)
            {
                y=y1+mdy*(x-x1)/mdx;
            }
            else
            {
                y=y1-mdy*(x-x1)/mdx;
            }
            lcd8544_putpix(x,y,mode);
            x=x+sx;
            l--;
        }
    }
    else
    {
        l=mdy;
        while (l>0)
        {
            if (dy>0)
            {
                x=x1+((mdx*(y-y1))/mdy);
            }
            else
            {
                x=x1+((mdx*(y1-y))/mdy);
            }
            lcd8544_putpix(x,y,mode);
            y=y+sy;
            l--;
        }
    }
    lcd8544_putpix(x2, y2, mode);

}



//   ( )
void lcd8544_rect(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char mode)
{
    lcd8544_line(x1,y1, x2,y1, mode);
    lcd8544_line(x1,y2, x2,y2, mode);
    lcd8544_line(x1,y1, x1,y2, mode);
    lcd8544_line(x2,y1, x2,y2, mode);
}

//      
void lcd8544_putchar(unsigned char px, unsigned char py, unsigned char ch, unsigned char mode)
{
    const unsigned char *fontpointer;


    if (ch<127)     //  
    {
        fontpointer=NewFontLAT;
        ch=ch-32;
    }
    else       //   
    {
        fontpointer=NewFontRUS;
        ch=ch-192;
    }

    unsigned char lcd_YP=7- (py & 0x07);    //     
    unsigned char lcd_YC=(py & 0xF8)>>3;    //     
    unsigned char x;


    for (x=0; x<6; x++)
    {

        unsigned char temp=*(fontpointer+ch*6+x);

        if (mode!=0)
        {
            temp=~temp;
            if (py>0) lcd8544_putpix(px, py-1, 1);   //      -   
        }

        temp&=0x7F;

        //lcd8544_buff[lcd_YC*84+px]=lcd8544_buff[lcd_YC*84+px] | (temp<<(7-lcd_YP));    //    
        lcd8544_buff[lcd_YC*84+px]= (temp<<(7-lcd_YP));
        if (lcd_YP<7)
        {
            //lcd8544_buff[(lcd_YC+1)*84+px] = lcd8544_buff[(lcd_YC+1)*84+px] | (temp>>(lcd_YP+1));    //    
            lcd8544_buff[(lcd_YC+1)*84+px] = (temp>>(lcd_YP+1));
        }
        px++;
        if (px>83) return;
    }
}


//   
void lcd8544_dec(unsigned int numb, unsigned char dcount, unsigned char x, unsigned char y, unsigned char mode)
{
    unsigned int divid=10000;
    unsigned char i;

    for (i=5; i!=0; i--)
    {

        unsigned char res=numb/divid;

        if (i<=dcount)
        {
            lcd8544_putchar(x, y, res+'0', mode);
            x=x+6;
        }

        numb%=divid;
        divid/=10;
    }
}


//       
void lcd8544_leftchline(unsigned char x, unsigned char y)
{
    if (x>0) lcd8544_line(x-1, y-1, x-1, y+6, 1);
}


//  
void lcd8544_putstr(unsigned char x, unsigned char y, const unsigned char str[], unsigned char mode)
{
    if (mode) lcd8544_leftchline(x, y);
    while (*str!=0)
    {
        lcd8544_putchar(x, y, 32, mode);
        lcd8544_putchar(x, y, *str, mode);
        x=x+6;
        str++;
    }
}


void init_spi(void)// SPI1
{
    /** SPI1 GPIO Configuration
           PA5    ------> SPI1_SCK
           PA7    ------> SPI1_MOSI
       */


    /*Enable or disable APB2 peripheral clock */
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef SPIConf;

    SPI_I2S_DeInit(SPI1);
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
    /*Configure GPIO pin */
    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_5|GPIO_Pin_7;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF;     //   .
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;   //    .
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL; //   .
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_10MHz;
    GPIO_Init(GPIOA, &GPIO_InitStruct);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource5, GPIO_AF_0);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_0);
    /* SS pin*/
    /*

       GPIO_SetBits(GPIOC, GPIO_Pin_3);
    */
    // ,      
    SPIConf.SPI_Direction = SPI_Direction_1Line_Tx;
    // ,    - Master
    SPIConf.SPI_Mode = SPI_Mode_Master;
    //    8  (=1 )
    SPIConf.SPI_DataSize = SPI_DataSize_8b;
    //  00
    SPIConf.SPI_CPOL = SPI_CPOL_Low;
    SPIConf.SPI_CPHA = SPI_CPHA_1Edge;
    SPIConf.SPI_NSS = SPI_NSS_Soft;
    //    (  ,       )
    SPIConf.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
    //      (..  )
    SPIConf.SPI_FirstBit = SPI_FirstBit_MSB;
    //    SPI
    SPI_Init(SPI1, &SPIConf);
    //   SPI1
    SPI_Cmd(SPI1, ENABLE);
    // SS = 1
    SPI_NSSInternalSoftwareConfig(SPI1, SPI_NSSInternalSoft_Set);

//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE);


}


void SPI_Send(uint8_t data)
{

    //GPIO_ResetBits(GPIOC, GPIO_Pin_3); // SS = 0
    SPI_SendData8(SPI1, data);  //  
    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET); // ,    
    lcd8544_Pause();
    //GPIO_SetBits(GPIOC, GPIO_Pin_3);
}


//void init_dma_to_spi(void)// DMA    SPI1
//{
//    DMA_InitTypeDef  DMA_to_SPI_InitStructure;
//
//    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
//    DMA_DeInit (DMA1_Channel3);
//    DMA_to_SPI_InitStructure.DMA_PeripheralBaseAddr =(uint32_t)&(SPI1->DR);
//    DMA_to_SPI_InitStructure.DMA_MemoryBaseAddr = (uint32_t)lcd8544_buff;
//    DMA_to_SPI_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;
//    DMA_to_SPI_InitStructure.DMA_BufferSize = 84*6;
//    DMA_to_SPI_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
//    DMA_to_SPI_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
//    DMA_to_SPI_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
//    DMA_to_SPI_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
//    DMA_to_SPI_InitStructure.DMA_Mode = DMA_Mode_Normal;
//    DMA_to_SPI_InitStructure.DMA_Priority = DMA_Priority_High;
//    DMA_to_SPI_InitStructure.DMA_M2M = DMA_M2M_Disable;
//    DMA_Init(DMA1_Channel3, &DMA_to_SPI_InitStructure);
//    /*       */
//
//    DMA_ITConfig(DMA1_Channel3, DMA_IT_TC , ENABLE);
//    DMA_ITConfig(DMA1_Channel3, DMA_IT_HT , ENABLE);
//    DMA_ITConfig(DMA1_Channel3, DMA_IT_TE , ENABLE);
//
//
//
//
//    NVIC_EnableIRQ(DMA1_Channel2_3_IRQn);
//    DMA_Cmd(DMA1_Channel3, DISABLE);
////   while ( !DMA_GetFlagStatus ( DMA2_FLAG_TC2 ) );
//
//}


//void startSPI(void)
//{
//    DMA_Cmd(DMA1_Channel3, DISABLE);
//    DMA_SetCurrDataCounter(DMA1_Channel3,84*6);
//    DMA_Cmd(DMA1_Channel3, ENABLE);
//}
