/*
**
**                           Main.c
**
**
**********************************************************************/
/*
   Last committed:     $Revision: 00 $
   Last changed by:    $Author: $
   Last changed date:  $Date:  $
   ID:                 $Id:  $

**********************************************************************/
#include "stm32f0xx_conf.h"
#include "onewire.h"
#include "f0xx-pcd8544.h"

volatile float tt;

void Set8Arr(uint8_t *Buff, uint8_t Len, uint8_t Byte)
{
    uint8_t i;
    for (i=0; i<Len; i++)
    {
        Buff[i] = Byte;
    }
}

void Display(int16_t t)
{
    static uint8_t str[30];
    snprintf(str, 28, "T=%3d.%1d", t/10, (uint8_t)(t%10));
    lcd8544_putstr(8, 8, str, 0);
    lcd8544_refresh(); //    
}

int main(void)
{
    uint8_t buf[9];

    GPIO_InitTypeDef GPIO_InitStruct;

    SystemCoreClockUpdate(); //    .

    SysTim_Init(100);        //   .
    OW_Init(); //  1Wire .
    lcd8544_init(); //  

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE); //    PB.

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_1;      //   PB.1.
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_OUT;  //    .
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //   (. .   ).
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL; //   .
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_10MHz;

    GPIO_Init(GPIOB, &GPIO_InitStruct);


    while(1)
    {
        //   .
        if (OW_Send(OW_SEND_RESET, "\xCC\x44", 2, 0, 0, OW_NO_READ) == OW_OK)
        {
            SysTim_DelayMS(800); //  800 .

            //    
            if (OW_Send(OW_SEND_RESET, "\xCC\xBE\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF", 11, &buf[0], 9, 2) == OW_OK)
            {

                if (OW_CRC8(&buf[0], 8) == buf[8])
                {

                    GPIO_SetBits(GPIOB, GPIO_Pin_1); // . 1   PB.1.
                    SysTim_DelayMS(100); //  100 .
                    GPIO_ResetBits(GPIOB, GPIO_Pin_1); // . 0   PB.1.

                    tt = ((float)((buf[1]<<8)|buf[0]))/16.0; //  .
                    Display((int16_t)(tt*10));

                }
            }
        }

    }
}
